#ifndef MY_I2C_H
#define MY_I2C_H

/* adc에 물린 센서의 주소 */
#define COMMD_1 0x8c // acc센서 x
#define COMMD_2 0xcc // acc센서 y
#define COMMD_3 0x9c // acc센서 z
#define COMMD_4 0xdc // piezo센서

#define SLAVE_ADDR (0x90 >> 1) // adc장치의 주소
#define I2C_DEV "/dev/i2c"

struct struct_read_buf {
	unsigned char acc[3][2];
	unsigned char piezo[2];
};

struct struct_i2c_comm {
	/* dev file descripter */
	int dev_fd;

	/* i2c에서 읽어온값을 저장할 버퍼 */
	struct struct_read_buf read_buf;

	/* struct_i2c_comm 소멸 */
	void (*close)();
	/* my_i2c.c 의 i2c_read함수에 연결 */
	void (*read)(int, const unsigned int);
};

/* struct_i2c_comm initialize */
extern struct struct_i2c_comm *i2c_open();

#endif
