#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <termios.h>
#include <sys/ioctl.h>

#include "blue.h"

#define DEBUG

static int serial_fd;

void bt_init()
{
	serial_fd = serial_init(B38400);
	serial_flush();
}

void bt_exit()
{
	serial_exit();
}

void bt_ir(char dev, char attached)
{
	struct blue_packet bt;

	bt.ctl = BT_CTL_IR;
	bt.attat = dev | attached;
	
	write(serial_fd, &bt, PACKET_SIZE);
}

void bt_send(struct blue_packet *btp, void *data, size_t byte)
{
	static char prevaddr = -1;
	int count = 0;

	if (prevaddr == btp->header.dest)
		usleep(40000);
	prevaddr = btp->header.dest;

	while (count < byte) {
		if (byte-count >= 12)
			memcpy(&btp->data[0], (char *)data+count, 12);
		else
			memcpy(&btp->data[0], (char *)data+count, byte-count);
		count += 12;
		write(serial_fd, btp, PACKET_SIZE);
		printf("send: %x %x %x\n", btp->data[0], btp->data[1], btp->data[2]);
	}
}

/*void bt_send(struct blue_packet *btp, void *data, size_t byte)
{
	int count = 0;

	while (count < byte) {
		if (byte <= 12)
			memcpy(&btp->data[0], (char *)data+count, byte);
		else if (byte-count > 12)
			memcpy(&btp->data[0], (char *)data+count, 12);
		else
			memcpy(&btp->data[0], (char *)data+count, byte-count);
		count += 12;
		write(serial_fd, btp, PACKET_SIZE);
		usleep(40000);
	}
	}*/

void
bt_make_packet(struct blue_packet *btp, unsigned char src,
	       unsigned char dest, unsigned char ctl)
{
	btp->header.src = src;
	btp->header.dest = dest;
	btp->ctl = ctl;
}

void bt_recv(struct blue_packet *btp, void *dest, size_t byte)
{
	int count = 0;

 	while (count < byte) {
		read(serial_fd, btp, PACKET_SIZE);
		printf("recv: %x %x %x\n", btp->data[0], btp->data[1], btp->data[2]);
		if (byte-count >= 12)
			memcpy((char *)dest+count, &btp->data[0], 12);
		else
			memcpy((char *)dest+count, &btp->data[0], byte-count);
		count += 12;
	}	
}

/*void bt_recv(struct blue_packet *btp, void *dest, size_t byte)
{
	int count = 0;

	while (count < byte) {
		read(serial_fd, btp, PACKET_SIZE);
		printf("recv: %x %x %x\n", btp->data[0], btp->data[1], btp->data[2]);
		if (byte <= 12)
			memcpy((char *)dest+count, &btp->data[0], byte);
		else if (byte-count > 12)
			memcpy((char *)dest+count, &btp->data[0], 12);
		else
			memcpy((char *)dest+count, &btp->data[0], byte-count);
		count += 12;
	}	
	}*/

