#ifndef _GPIODEV_HEADER_
#define _GPIODEV_HEADER_

#define IRDA_MAJOR	253	  	// 주번호
#define DEVICE_NAME	"irda"    	// 디바이스 파일 이름
#define DEVICE_PATH	"/dev/irda"	// 디바이스 파일 경로

#define GPIO_TX		10  
#define GPIO_RX_DOWN	11
#define GPIO_RX_RIGHT	12
#define GPIO_RX_UP	13
#define GPIO_RX_LEFT	14

#define MASK_GPIO_TX		( 1 << GPIO_TX ) 
#define MASK_GPIO_RX_DOWN	( 1 << GPIO_RX_DOWN ) 
#define MASK_GPIO_RX_RIGHT	( 1 << GPIO_RX_RIGHT)
#define MASK_GPIO_RX_UP		( 1 << GPIO_RX_UP )
#define MASK_GPIO_RX_LEFT	( 1 << GPIO_RX_LEFT )

#define ALL_RX_MASK	( MASK_GPIO_RX_DOWN | MASK_GPIO_RX_RIGHT | MASK_GPIO_RX_UP | MASK_GPIO_RX_LEFT )

#define SET_RX_DOWN	0
#define SET_RX_RIGHT	1
#define SET_RX_UP	2
#define SET_RX_LEFT	3
#define IRDA_WRITE	4
#define IRDA_READ	5

#define DOWN_CHECK	0
#define RIGHT_CHECK	1
#define UP_CHECK	2
#define LEFT_CHECK	3

#define DOWN_ATTACH	0
#define RIGHT_ATTACH	1
#define UP_ATTACH	2
#define LEFT_ATTACH	3

#define ATTACHED	1
#define DETACHED	0

struct irda_instance
{
	int fd;
};

void init_irda(struct irda_instance *irda);
int is_attached(struct irda_instance *irda, int direction);
void irda_close(struct irda_instance *irda);
#endif // _GPIODEV_HEADER_
