#define POCKETMON_TITLE_IMAGE_PATH	"images/pocketmon_title.raw"
#define GAME_OVER_IMAGE_PATH		"images/game_over.raw"
#define ATTACK_UP_IMAGE_PATH		"images/attack_up.raw"	
#define ATTACK_DOWN_IMAGE_PATH		"images/attack_down.raw"
#define VS_IMAGE_PATH			"images/vs.raw"

#define PICACHU_IMAGE_PATH		"images/picachu.raw"
#define PICA_DAMAGED_IMAGE_PATH		"images/pica_damaged.raw"
#define PICA_ATTACK_IMAGE1_PATH		"images/picachu_attack1.raw"
#define PICA_ATTACK_IMAGE2_PATH		"images/picachu_attack2.raw"
#define PICA_ATTACK_IMAGE3_PATH		"images/picachu_attack3.raw"
#define PICA_ATTACK_IMAGE4_PATH		"images/picachu_attack4.raw"
#define PICA_ATTACK_IMAGE5_PATH		"images/picachu_attack5.raw"
#define PICA_ATTACK_IMAGE6_PATH		"images/picachu_attack6.raw"
#define PICA_ATTACK_IMAGE7_PATH		"images/picachu_attack7.raw"
#define PICA_STATE_BAR_IMAGE1_PATH	"images/pica_state_bar1.raw"
#define PICA_STATE_BAR_IMAGE2_PATH	"images/pica_state_bar2.raw"
#define PICA_STATE_BAR_IMAGE3_PATH	"images/pica_state_bar3.raw"
#define PICA_STATE_BAR_IMAGE4_PATH	"images/pica_state_bar4.raw"

#define FIRY_IMAGE_PATH			"images/firy.raw"
#define FIRY_ATTACK_IMAGE1_PATH		"images/firy_attack1.raw"
#define FIRY_ATTACK_IMAGE2_PATH		"images/firy_attack2.raw"
#define FIRY_ATTACK_IMAGE3_PATH		"images/firy_attack3.raw"
#define	FIRY_ATTACK_IMAGE4_PATH		"images/firy_attack4.raw"
#define FIRY_ATTACK_IMAGE5_PATH		"images/firy_attack5.raw"
#define FIRY_ATTACK_IMAGE6_PATH		"images/firy_attack6.raw"
#define FIRY_STATE_BAR_IMAGE1_PATH	"images/firy_state_bar1.raw"
#define FIRY_STATE_BAR_IMAGE2_PATH	"images/firy_state_bar2.raw"
#define FIRY_STATE_BAR_IMAGE3_PATH	"images/firy_state_bar3.raw"
#define FIRY_STATE_BAR_IMAGE4_PATH	"images/firy_state_bar4.raw"

#define POCKETMON_TITLE_IMAGE_PATH	"images/pocketmon_title.raw"

#define PICA_ATTACK_WAV_PATH		"sound/pica_attack.wav"
#define FIRY_ATTACK_WAV_PATH		"sound/firy_attack.wav"

#define POCKETMON_IMAGE_X_SIZE		300
#define POCKETMON_IMAGE_Y_SIZE		300

#define STATE_BAR_IMAGE_X_SIZE		300
#define STATE_BAR_IMAGE_Y_SIZE		70

#define ATTACK_IMAGE_X_SIZE		100
#define ATTACK_IMAGE_Y_SIZE		30

#define VS_IMAGE_X_SIZE			400
#define VS_IMAGE_Y_SIZE			400

#define GAME_OVER_IMAGE_X_SIZE		640
#define GAME_OVER_IMAGE_Y_SIZE		480

#define POCKETMON_TITLE_IMAGE_X_SIZE	500
#define POCKETMON_TITLE_IMAGE_Y_SIZE	400

#define POCKETMON_IMAGE_X_OFFSET	170
#define POCKETMON_IMAGE_Y_OFFSET	40

#define STATE_BAR_IMAGE_X_OFFSET	160
#define STATE_BAR_IMAGE_Y_OFFSET	340

#define ATTACK_UP_IMAGE_X_OFFSET	270
#define ATTACK_UP_IMAGE_Y_OFFSET	0

#define ATTACK_DOWN_IMAGE_X_OFFSET	270
#define ATTACK_DOWN_IMAGE_Y_OFFSET	450

#define VS_IMAGE_X_OFFSET		120
#define VS_IMAGE_Y_OFFSET		40

#define GAME_OVER_IMAGE_X_OFFSET	0
#define GAME_OVER_IMAGE_Y_OFFSET	0

#define POCKETMON_TITLE_IMAGE_X_OFFSET	70
#define POCKETMON_TITLE_IMAGE_Y_OFFSET	40

#define POCKETMON_IMAGE_SIZE		( POCKETMON_IMAGE_X_SIZE * POCKETMON_IMAGE_Y_SIZE )
#define STATE_BAR_IMAGE_SIZE		( STATE_BAR_IMAGE_X_SIZE * STATE_BAR_IMAGE_Y_SIZE )
#define ATTACK_IMAGE_SIZE		( ATTACK_IMAGE_X_SIZE * ATTACK_IMAGE_Y_SIZE )
#define VS_IMAGE_SIZE			( VS_IMAGE_X_SIZE * VS_IMAGE_Y_SIZE )
#define GAME_OVER_IMAGE_SIZE		( GAME_OVER_IMAGE_X_SIZE * GAME_OVER_IMAGE_Y_SIZE )
#define POCKETMON_TITLE_IMAGE_SIZE	( POCKETMON_TITLE_IMAGE_X_SIZE * POCKETMON_TITLE_IMAGE_Y_SIZE )
#define PICA_ATTACK_WAV_SIZE		324052
#define FIRY_ATTACK_WAV_SIZE		258092

#define POCKETMON_PICACHU		1
#define POCKETMON_FIRY			2

#define POCKETMON_SKILL_THUNDER		1
#define POCKETMON_SKILL_FIRE		2

#define THUNDER_BASIC_DAMAGE		1
#define FIRE_BASIC_DAMAGE		1

#define FIGHTING			1
#define NO_FIGHT			2

#define POWER_OFF			1
#define INFO				2
#define STOP				3

#define SLEEP_TIME			1

struct skill
{
	int skill_name;
	int damage;
	struct skill *next;
};
typedef struct skill skill;
struct skill *head_skill;

struct image
{
	unsigned short pocketmon[POCKETMON_IMAGE_SIZE];
	unsigned short damaged_pocketmon[POCKETMON_IMAGE_SIZE];
	unsigned short attack1[POCKETMON_IMAGE_SIZE];
	unsigned short attack2[POCKETMON_IMAGE_SIZE];
	unsigned short attack3[POCKETMON_IMAGE_SIZE];
	unsigned short attack4[POCKETMON_IMAGE_SIZE];
	unsigned short attack5[POCKETMON_IMAGE_SIZE];
	unsigned short attack6[POCKETMON_IMAGE_SIZE];
	unsigned short attack7[POCKETMON_IMAGE_SIZE];
	unsigned short state_bar[4][STATE_BAR_IMAGE_SIZE];
};
typedef struct image image;

struct sound
{
	unsigned char *pocketmon_attack_wav;
	int wav_size;
};
typedef struct sound sound;

struct pocketmon
{
	int race;
	int life;
	int level;
	int exp;
	int fight_flag;
	struct skill *p_skill;
	struct image *p_image;
	struct sound *p_sound;
};
typedef struct pocketmon pocketmon;

struct pocketmon_blue_packet
{
	int id;
	int race;
	int attack_damage;
};
typedef struct pocketmon_blue_packet p_blue_packet;

struct pocketmon *p_mon;
struct pocketmon_blue_packet *p_blue_data;

unsigned short _game_over[GAME_OVER_IMAGE_SIZE];
unsigned short attack_up[ATTACK_IMAGE_SIZE];
unsigned short attack_down[ATTACK_IMAGE_SIZE];
unsigned short vs[VS_IMAGE_SIZE];

int acc_key=1;
int ts_key=1;
int power_off=0;

pthread_mutex_t mutex;

int select_pocketmon(void);
void init_pocketmon_app(int);
void init_pocketmon_skill(void);
void display_pocketmon_image(void);
void *ts_thread_func(void *arg);
void *blue_thread_func(void *arg);
void *attack_wav_thread_func(void *arg);
int check_click_zone(short x, short y);
int check_pocketmon_zone(short x, short y);
void attack(void);
void damaged(struct pocketmon_blue_packet *);
void display_attack_effect(void);
void display_damaged_effect(void);
void game_over(void);
void cleanup();
