#define	RED_BLOCK_B_IMAGE_PATH		"images/red_block_b.raw" 
#define GREEN_BLOCK_B_IMAGE_PATH	"images/green_block_b.raw"
#define BLUE_BLOCK_B_IMAGE_PATH		"images/blue_block_b.raw"
#define YELLOW_BLOCK_B_IMAGE_PATH	"images/yellow_block_b.raw"

#define T_OK_IMAGE_PATH			"images/t_ok.raw"
#define T_NO_IMAGE_PATH			"images/t_no.raw"

#define T_OK_WAV_PATH			"sound/t_ok.wav"
#define T_NO_WAV_PATH			"sound/t_no.wav"

#define BLOCK_IMAGE_X_SIZE		100
#define BLOCK_IMAGE_Y_SIZE		100

#define T_OK_NO_IMAGE_X_SIZE		300
#define T_OK_NO_IMAGE_Y_SIZE		300

#define BLOCK_IMAGE_SIZE		( BLOCK_IMAGE_X_SIZE * BLOCK_IMAGE_Y_SIZE )
#define T_OK_NO_IMAGE_SIZE		( T_OK_NO_IMAGE_X_SIZE * T_OK_NO_IMAGE_Y_SIZE )
#define T_OK_WAV_SIZE			119900
#define T_NO_WAV_SIZE			156716

#define PUZZLE_BASE_X_OFFSET		170
#define PUZZLE_BASE_Y_OFFSET		90

#define T_OK_NO_IMAGE_X_OFFSET		170
#define T_OK_NO_IMAGE_Y_OFFSET		90

#define COLOR_RED			1
#define COLOR_GREEN			2
#define COLOR_BLUE			3
#define COLOR_YELLOW			4

#define PUZZLE_BLOCK_NO1		1
#define PUZZLE_BLOCK_NO2		2
#define PUZZLE_BLOCK_NO3		3
#define PUZZLE_BLOCK_NO4		4
#define PUZZLE_BLOCK_NO5		5
#define PUZZLE_BLOCK_NO6		6
#define PUZZLE_BLOCK_NO7		7

#define DOWN				0
#define LEFT				1
#define TOP				2
#define RGHT				3

struct puzzle_block
{
	int flag;
	int color;
	int x_offset;
	int y_offset;
} block[3][3];

unsigned short red_block_b[BLOCK_IMAGE_SIZE];
unsigned short green_block_b[BLOCK_IMAGE_SIZE];
unsigned short blue_block_b[BLOCK_IMAGE_SIZE];
unsigned short yellow_block_b[BLOCK_IMAGE_SIZE];

unsigned short t_ok[T_OK_NO_IMAGE_SIZE];
unsigned short t_no[T_OK_NO_IMAGE_SIZE];

unsigned char t_ok_wav[T_OK_WAV_SIZE];
unsigned char t_no_wav[T_NO_WAV_SIZE];

int power_off=0;

void init_t_block_client_app(void);
void init_block(void);
void make_block(int block_no, int color, int rotation_cnt);
void display_block(void);
void rotate_block(int rotation_cnt);
void *bt_thread_func(void *arg);
void cleanup();
