#define	RED_BLOCK_IMAGE_PATH		"images/red_block.raw" 
#define GREEN_BLOCK_IMAGE_PATH		"images/green_block.raw"
#define BLUE_BLOCK_IMAGE_PATH		"images/blue_block.raw"
#define YELLOW_BLOCK_IMAGE_PATH		"images/yellow_block.raw"

#define BLOCK_IMAGE_X_SIZE		48
#define BLOCK_IMAGE_Y_SIZE		48

#define BLOCK_IMAGE_SIZE		( BLOCK_IMAGE_X_SIZE * BLOCK_IMAGE_Y_SIZE )

#define PUZZLE_BASE_X_OFFSET		104
#define PUZZLE_BASE_Y_OFFSET		24

#define COLOR_RED			1
#define COLOR_GREEN			2
#define COLOR_BLUE			3
#define COLOR_YELLOW			4

#define PUZZLE_BLOCK_NO1		1
#define PUZZLE_BLOCK_NO2		2
#define PUZZLE_BLOCK_NO3		3
#define PUZZLE_BLOCK_NO4		4
#define PUZZLE_BLOCK_NO5		5
#define PUZZLE_BLOCK_NO6		6
#define PUZZLE_BLOCK_NO7		7

#define TOP				2
#define RIGHT				3
#define BOTTOM				0
#define LEFT				1			

#define POWER_OFF			1
#define INFO				2
#define STOP				3

struct puzzle_block
{
	char block_id;
	char color;
	char correct;
	char rot;
} __attribute__((packed));

struct puzzle_map
{
	int flag;
	int color;
	int x_offset;
	int y_offset;
} map[9][9];

unsigned short red_block[BLOCK_IMAGE_SIZE];
unsigned short green_block[BLOCK_IMAGE_SIZE];
unsigned short blue_block[BLOCK_IMAGE_SIZE];
unsigned short yellow_block[BLOCK_IMAGE_SIZE];

struct blue_packet bt;
struct tet_block tet[4];
unsigned int data;

int t_puzzle_complete=0;
int t_puzzle_bottom=0;
int t_puzzle_left=0;
int t_puzzle_top=0;
int t_puzzle_right=0;
int power_off=0;

void init_t_block_server_app(void);
void make_puzzle_map(struct tet_block tet[4]);
void make_puzzle_block(int direction, struct tet_block *tet, int flag);
void display_puzzle_map(void);
void display_t_puzzle_image(void);
void *ts_thread_func(void *arg);
void *bt_thread_func(void *arg);
int check_click_zone(short x, short y);
//void check_answer_blocki(int direction);
void cleanup();
